use crate::vec_util::{IVec2Helper, IVec2Iter};
use glam::IVec2;

#[derive(Copy, Clone)]
pub struct IRect {
    pub pos: IVec2,
    pub size: IVec2,
}

impl IRect {
    pub fn new(x: i32, y: i32, w: i32, h: i32) -> IRect {
        IRect {
            pos: IVec2 { x, y },
            size: IVec2 { x: w, y: h },
        }
    }

    pub fn pos2(&self) -> IVec2 {
        self.pos + self.size
    }

    pub fn iter(&self) -> IVec2Iter {
        self.pos.iter_to(self.size)
    }

    pub fn contains(&self, point: IVec2) -> bool {
        let p2 = self.pos2();
        point.x >= self.pos.x && point.y >= self.pos.y && point.x < p2.x && point.y < p2.y
    }
}
